commit:     3ab261a36daa5a0b111a191041bfed629a8f399d
Author:     Fabian Groffen <grobian <AT> gentoo <DOT> org>
AuthorDate: Sun Dec 23 11:50:08 2018 +0000
Commit:     Fabian Groffen <grobian <AT> gentoo <DOT> org>
CommitDate: Sun Dec 23 11:53:17 2018 +0000
URL:        https://gitweb.gentoo.org/repo/proj/prefix.git/commit/?id=3ab261a3

scripts/bootstrap-prefix.sh: allow direct rsync in bootstrap_tree

To test bootstrapping on a more recent tree than the latest snapshot,
allow special TREE_FROM_SRC envvar to specify the source to rsync after
unpacking a snapshot.  This is intended for bootstrap testing only,
normal usage should never use this, hence the support being a bit
brittle.  The exit code of this additional rsync step is ignored.

Signed-off-by: Fabian Groffen <grobian <AT> gentoo.org>

 scripts/bootstrap-prefix.sh | 9 +++++++++
 1 file changed, 9 insertions(+)

diff --git a/scripts/bootstrap-prefix.sh b/scripts/bootstrap-prefix.sh
index fbaed65070..48ac9628de 100755
--- a/scripts/bootstrap-prefix.sh
+++ b/scripts/bootstrap-prefix.sh
@@ -543,6 +543,15 @@ bootstrap_tree() {
        else
                do_tree http://dev.gentoo.org/~grobian/distfiles 
prefix-overlay-${PV}.tar.bz2
        fi
+       local ret=$?
+       if [[ -n ${TREE_FROM_SRC} ]]; then
+               rsync -av --delete \
+                       --exclude=.unpacked \
+                       --exclude=distfiles \
+                       --exclude=snapshots \
+                       "${TREE_FROM_SRC}"/ "${PORTDIR}"/
+       fi
+       return $ret
 }
 
 bootstrap_startscript() {

Reply via email to